module ParallelBatchApi
  class ErrorResponse
    attr_reader :error, :code

    def initialize(error)
      @error = error
      @code = @error.status_code if @error.respond_to?(:status_code)
    end

    def execute
      [code,  { 'Content-Type' => 'application/json' }, [body.to_json]]
    end

    def body
      { message: error.message }
    end

    def code
      @code || 500
    end
  end
end
