require 'parallel_batch_api/rack_processor'
module ParallelBatchApi
  module Processor
    def process(env)
      build_response(parallel_process(env.deep_dup))
    end

    def parallel_process(env)
      Parallel.map(requests(env), in_threads: thread_size) do |item|
        ActiveRecord::Base.connection_pool.with_connection do
          e = env.deep_dup
          rack = ParallelBatchApi::RackProcessor.new(e, item, @app)
          rack.process
        end
      end
    end

    def requests(env)
      build_requests(env)
    end

    def thread_size
      ParallelBatchApi.thread || 1
    end
  end
end
